function param1()
  return "間隔", 0, 100, 30
end

function param2()
  return "長さ", 0, 100, 30
end

function param3()
	return "長さのジッタ", 0, 100, 15
end

function param4()
	return "位置のジッタ", 0, 100, 10
end

function param5()
 	return "角度", 0, 100, 50
end

function param6()
	return "22.5度階差", 0, 1, 1
end

function param7()
	return "消失点の使用", 0, 1, 0
end

function param8()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0
end

bs_setmode( 1 )

function use_base()
  return true
end

function main( x, y, p )

	local mul = 0.08
	local rdm1 = math.abs(bs_grand( 0, 2 ))%4 * bs_param3()/100
	local rdmX = bs_grand( 0, 1 ) * bs_param4() * 0.25
	local rdmY = bs_grand( 0, 1 ) * bs_param4() * bs_param4() * 0.1

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param8() )

	local bsx,bsy = bs_base()

	local pm = 1
	if ( bs_param5() < 50 ) then pm = -1 end

	local add = math.floor( math.abs( ( bs_param5() - 50 ) / 12.5 ) ) * 22.5 * 0.0174 * pm

	if ( bs_param6()==0 ) then add = ( bs_param5() - 50 ) * 1.8 * 0.0174 end

	local rotate = bs_atan( dx, dy ) + add

	if ( bs_param7() == 1 ) then rotate = bs_atan( bsx - x, bsy -y )+ 90 * 0.0174 + add end

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < ( w *(1+bs_param1()) * (1+bs_param1()) * 0.002 ) then
				return 0
			end
	end

	if drawLock < 250 then
		drawLock = drawLock + 1
		return 0
	end

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then

				bs_bezier_move( rdmX , rdmY )
				bs_bezier_mul( w * mul , w * (mul + bs_param2() * bs_param2()/1000 + rdm1) * 0.1 ) 
				bs_bezier_rotate( rotate )
				bs_bezier_move( x , y )

				bs_fill( r,g,b,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

drawLock = 0

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}


-- ブラシ形状データ

shape = { 1, 0.00, 50.00, 3, 0.00, 50.00, -1.33, 34.21, -1.67, 23.68, 3, -2.00, 13.16, -2.00, 7.89, -2.00, 2.63, 
	3, -2.00, -2.63, -1.99, -29.05, -1.67, -34.21, 3, -1.33, -39.47, 0.00, -50.00, 0.00, -50.00, 3, 0.00, 
	-50.00, 1.33, -39.47, 1.67, -34.21, 3, 1.99, -29.05, 2.00, -2.63, 2.00, 2.63, 3, 2.00, 7.89, 1.84, 18.34, 
	1.67, 23.68, 3, 1.33, 34.21, 0.00, 50.00, 0.00, 50.00, 0 }
