function param1()
	return "大きさのジッタ", 0, 100, 0
end

function param2()
	return "位置のジッタ", 0, 100, 0
end

function param3()
	return "色のジッタ", 0, 100, 0
end

function param4()
	return "グリッド45度", 0, 1, 1
end

function param5()
	return "グリッド間隔", 1, 100, 30
end

function param6()
	return "筆圧透明度", 0, 1, 0
end

function default_size()
  return 10, 0
end

bs_setmode( 1 )

function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local mul = 0.04
	local rdm0 = 1 -2 * ( math.random(2) % 2 )
	local rdmSpin = bs_grand( 0, 3.14 )
	local rdmSize = math.random() * bs_param1()/500
	local rdmValue = math.floor( bs_grand( 0, 128 ) % 128 * bs_param3()/100 ) * rdm0

	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param6() )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param3()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param3()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param3()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local canvasW = bs_canvas_width()
	local canvasH = bs_canvas_height() 
	local dpi = bs_canvas_dpi() 
	local GridReso = 16 * bs_param5() / 5

	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso
	local GridSpin = bs_param4()

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end


	local seed = gridX * gridX * gridY * gridY
				math.randomseed( seed )
	local rdmSpin = math.random() * 3.14

	gridX = gridX +  bs_grand( 0,0.5 )%0.5 * GridReso * bs_param2()/100
	gridY = gridY +  bs_grand( 0,0.5 )%0.5 * GridReso * bs_param2()/100

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < GridReso/2 then
				return 0
			end
	end

	local er =  50 * (mul+rdmSize) * w
	bs_ellipse( gridX, gridY, er, er, rdmSpin, nr,ng,nb,a )

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

