function param1()
  return "ブラシ間隔", 0, 100, 20
end

function param2()
  return "網目数", 0, 100, 50
end

function param3()
  return "網目数ジッタ", 0, 100, 20
end

function param4()
  return "網密度", 0, 100, 10
end

function param5()
  return "線幅", 0, 100, 20
end

function param6()
  return "回転", 0, 1, 1
end

function default_size()
  return 20, 1
end

function set_line( w, num )
  bs_polygon( 0.0, -0.05 )
  bs_polygon( 0.2, -0.05 )
  bs_polygon( 1.0, 0.0 )
  bs_polygon( 0.2, 0.05 )
  bs_polygon( 0.0, 0.05 )
  bs_polygon( -0.2, 0.05 )
  bs_polygon( -1.0, 0.0 )
  bs_polygon( -0.2, -0.05 )
  bs_polygon( 0.0, -0.05 )
  bs_polygon_mul( w*num*0.8, (1+bs_param5()/50)*w )
end

function main( x, y, p )

  local w = bs_width_max() * 0.5
  if w < 10 then
    w = 10
  end

  if not firstDraw then
    local distance = bs_distance( lastDrawX - x, lastDrawY - y )
    if distance < w * ( 1+(100-bs_param4())/100) * 4 * (1+bs_param1())/25 then
      return 0
    end
  end

  local r,g,b = bs_fore()
  local dx,dy = bs_dir()
  local nx,ny = bs_normal()

	local num = 1 + math.floor( bs_param2()/10 ) + math.floor( math.random(1+bs_param3()/10) )
	local rdmSpin = 0
		if ( bs_param6()==1 ) then rdmSpin = math.random() * 3.14 end

	local density = 0.6 + 2 * (100-bs_param4())/100

  local i
  for i=0,num do
    local idx = i - num/2
    set_line( w, num )
    bs_polygon_move( 0, -idx * w * density )
    bs_polygon_rotate( bs_atan( dx, dy ) + 0 )
		bs_polygon_rotate( rdmSpin )
    bs_polygon_move( x, y )
    bs_fill( r,g,b, 255 )
  end

  for i=0,num do
    local idx = i - num/2
    set_line( w, num )
    bs_polygon_move( 0, -idx * w * density )
    bs_polygon_rotate( bs_atan( dx, dy ) + 3.14159/2 )
		bs_polygon_rotate( rdmSpin )
    bs_polygon_move( x, y )
    bs_fill( r,g,b, 255 )
  end

  lastDrawX = x
  lastDrawY = y
  firstDraw = false

  return 1
end

lastDrawX = 0
lastDrawY = 0
firstDraw = true
