function param1()
  return "筆毛数", 10, 100, 25
end

function param2()
  return "筆毛数ジッタ", 0, 100, 30
end

function param3()
  return "筆毛間隔", 0, 100, 35
end

function param4()
  return "にじみ量", 0, 100, 25
end

function param5()
  return "筆圧にじみ", 0, 100, 25
end

function param6()
	return "筆圧透明度", 0, 1, 0
end

function param7()
  return "かすれ筆圧", 0, 1, 0
end

function default_size()
  return 10, 0.85
end

bs_setmode( 1 )

function main( x, y, p )

	local mul = 0.04
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param6() )

	local distance = bs_distance( lastDrawX - x, lastDrawY - y )
	local prssWidth = 1.5 + 10 * p * bs_param5()/100

	if ( not firstDraw ) then
			if distance < w then
				return 0
			end
	end

	if ( drawCount < 250 ) then
		drawCount = drawCount + 1
		return 0
	end

	local code = ''

	currentTime = bs_ms()


		for stk=0, num do

		local id = 1

			repeat

				local acc = 0

				code = cmdcon[ shape[id] ]

				if (code=='z') then

						if ( previousTime==currentTime ) then
							acc = 0
						else
							acc = distance / (currentTime - previousTime)
						end

						local rdm0 = 1 -2 * ( math.random(2) % 2 )

						bs_bezier_rotate( rdm1 )
						bs_bezier_mul( mul * w * ( 1 + acc/8 ), mul * w * prssWidth * bs_param4()/100 * rdm0 * rdmWidth[stk] )
						bs_bezier_move( 0, ( stk - num/2 ) * w * bs_param3()/25 + offset[stk] )
						bs_bezier_rotate( bs_atan( dx, dy ) )
						bs_bezier_move( x, y )

						local faintly = 1 -2 * ( math.random(2) % 2 )
						if ( bs_param7()==1 ) then 
							if ( faintly==-1 ) then
								bs_fill( 255,255,255,0 )
							else
								bs_fill( r,g,b,a )
							end
						else 
							bs_fill( r,g,b,a )
						end

						id = id + 1

				else
					id = ( cmd[code] or cmd.default )( shape, id+1 )
				end

			until id > #shape

		end


	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	previousTime = currentTime

	return 1
end


bs_setmode( 1 )
lastDrawX = 0
lastDrawY = 0
firstDraw = true

currentTime, previousTime = 0, 0
drawCount = 0

num = 2 * math.floor( bs_param1()/10 ) + math.floor( math.random( 1 + bs_param2()/10 ) )
offset = {}
rdmWidth = {}

for i=0, num do
	offset[i] = bs_grand( 0, bs_width_max()/num ) * 4.5
	rdmWidth[i] = math.random(70,130)/100
end

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ

shape = { 1, 4.27, 24.00, 3, -5.32, 23.45, -14.20, 20.22, -21.03, 17.57, 3, -26.80, 4.76, -29.74, 2.76, -31.88, 
	-0.11, 3, -33.94, -2.86, -36.56, -10.29, -35.73, -12.31, 3, -26.59, -12.69, -19.53, -14.37, -11.16, 
	-14.91, 3, 0.41, -15.70, -1.24, -15.65, 6.32, -16.29, 3, 10.49, -16.65, 17.05, -15.89, 23.22, -14.94, 
	3, 28.21, -14.18, 26.32, -13.31, 36.08, -13.40, 3, 34.79, -7.86, 32.61, 5.89, 26.58, 11.39, 3, 21.61, 
	12.69, 15.13, 18.89, 4.27, 24.00, 0 }

