function param1()
  return "ブラシ間隔", 10, 100, 50
end

function param2()
	return "大きさのジッタ", 0, 100, 5
end

function param3()
	return "位置のジッタ", 0, 100, 5
end

function param4()
	return "色のジッタ", 0, 100, 0
end

function param5()
	return "グリッドスナップ", 0, 1, 1
end

function param6()
	return "グリッド45度", 0, 1, 1
end

function param7()
	return "グリッド間隔", 1, 100, 40
end

function param8()
	return "筆圧透明度", 0, 1, 0
--	return "筆圧不透明度", 0, 100, 100
end



function roundCalc( n )

	local n1,n2 = math.modf(n)
	local check = n2 - 0.5

	if ( check < 0 ) then num = n1
		else num = n1 + 1
	end

	return num
end


function main( x, y, p )

	local rdm0 = 1 -2 * ( math.random(2) % 2 )

	local mul0 = 0.25
	local mul = 0.08 * mul0
	local w = bs_width()
	local dx,dy = bs_dir()
	local nx,ny = bs_normal()
	local r,g,b = bs_fore()
	local a = 255 * bs_opaque() * ( 1 - (1 - p) * bs_param8() )
--	local a = 255 * bs_opaque() * ( 1 - (1 - p) * (1 - bs_param8()/100) )

	local rdm0R = 1 - 2 * ( math.random(2) % 2 )
	local rdm0G = 1 - 2 * ( math.random(2) % 2 )
	local rdm0B = 1 - 2 * ( math.random(2) % 2 )
	local rdmValueR = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0R
	local rdmValueG = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0G
	local rdmValueB = math.floor( bs_grand( 0, 128 ) % 128 * bs_param4()/100 ) * rdm0B
	local nr,ng,nb = r+rdmValueR, g+rdmValueG, b+rdmValueB
			if (nr > 255) then nr = 255 end
			if (ng > 255) then ng = 255 end
			if (nb > 255) then nb = 255 end
			if (nr < 0) then nr = 0 end
			if (ng < 0) then ng = 0 end
			if (nb < 0) then nb = 0 end

	local SpinCheck = 1
	local GridLock = bs_param5()
	local GridSpin = bs_param6()
	local GridReso = mul0 * 16 * bs_param7() / 5
	local gridX = roundCalc( x / GridReso ) * GridReso
	local gridY = roundCalc( y / GridReso ) * GridReso

	if ( GridSpin==1 ) then
			local remX = x % GridReso - ( x + GridReso/2 ) % GridReso
			local remY = y % GridReso - ( y + GridReso/2 ) % GridReso
			if ( remX>0 ) then 
				gridX = roundCalc( ( x+GridReso/2 ) / GridReso ) * GridReso	- GridReso/2	
				if ( remY>0 ) then gridY = gridY - GridReso/2
					else gridY = gridY + GridReso/2
				end
			end
	end


	if ( GridLock==1 ) then
				local seed = gridX * gridX * gridY * gridY
				math.randomseed( seed )
	end

	local rdmSpin = math.random() * 3.14
	local rdmSize = mul0 * math.random() * bs_param2()/500

	if ( SpinCheck == 0 ) then dx,dy = 0,0 rdmSpin = 0 end
	if ( GridLock == 0 ) then 
			gridX,gridY = x,y	
			GridReso = 1000
			math.randomseed(bs_ms()) 
			rdmSize = rdm0 * math.random() * bs_param2()/1000
			if ( SpinCheck == 1 ) then rdmSpin = math.random() * 3.14 end
	end

	gridX = gridX + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param3()/100  * (1 -2 * ( math.random(2) % 2 ))
	gridY = gridY + bs_grand( 0,0.5 )%0.5 * GridReso * bs_param3()/100  * (1 -2 * ( math.random(2) % 2 ))


	local interval = w * bs_param1()/5
	if ( GridLock == 1 ) then interval = GridReso/3 end 

	if not firstDraw then
		local distance = bs_distance( lastDrawX - x, lastDrawY - y )
			if distance < interval then
				return 0
			end
	end

	local id = 1
	local code = ''

	repeat

		code = cmdcon[shape[id]]

		if (code=='z') then
				bs_bezier_mul( (mul+rdmSize) * w, (mul+rdmSize) * w )
				bs_bezier_rotate( rdmSpin )
				bs_bezier_move( gridX, gridY )
				bs_fill( nr,ng,nb,a )
				id = id + 1
		else
			id = ( cmd[code] or cmd.default )( shape, id+1 )
		end

	until id > #shape

	lastDrawX = x
	lastDrawY = y
	firstDraw = false

	return 1
end


lastDrawX = 0
lastDrawY = 0
firstDraw = true

cmdcon = { 'b', 'm', 'c', 'l'}
cmdcon[0] = 'z'
cmd = cmd or {
	b = function( bz, i )
			bs_bezier_begin( bz[i], bz[i+1] )
			return i+2
		end,
	m = function( bz, i )
			bs_bezier_m( bz[i], bz[i+1] )
			return i+2
		end,
	c = function( bz, i )
			bs_bezier_c( bz[i], bz[i+1], bz[i+2], bz[i+3], bz[i+4], bz[i+5] )
			return i+6
		end,
	l = function( bz, i )
			bs_bezier_l( bz[i], bz[i+1] )
			return i+2
		end,

	default = function( bz, i )
			return  i
		end,
	}

-- ブラシ形状データ


shape = { 1, -35.86, -33.28, 3, -24.45, -45.92, -7.00, -52.43, 11.27, -45.80, 3, 29.53, -39.18, 51.41, -14.29, 
	50.00, 6.77, 3, 48.49, 29.29, 44.40, 42.86, 1.40, 45.80, 3, -21.29, 47.36, -46.02, 35.20, -50.00, 21.35, 
	3, -53.98, 7.51, -48.23, -19.59, -35.86, -33.28, 2, -20.29, 18.86, 3, -13.37, 24.60, 15.27, 33.44, 21.88, 
	17.03, 3, 27.94, 1.98, 30.00, -6.25, 16.01, -16.71, 3, 2.02, -27.17, -14.96, -21.82, -20.66, -13.04, 
	3, -26.40, -4.21, -28.10, 12.38, -20.29, 18.86, 0 }
